package tools;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author ubik
 */
public class NullStream {

    public static final OutputStream out = new OutputStream() {
        @Override
        public void write(int b) throws IOException {
        }
    };
    public static final InputStream in = new InputStream() {
        @Override
        public int read() throws IOException {
            return -1; // End of stream signal
        }
    };

    public static <T extends OutputStream> T out(Class<T> clazz) {
        T res = null;
        try {
            Constructor<T> constr = clazz.getConstructor(OutputStream.class);
            res  = constr.newInstance(out);
        } catch (InstantiationException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InvocationTargetException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NoSuchMethodException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        }
        return res;
    }
    
    public static <T extends InputStream> T in(Class<T> clazz) {
        T res = null;
        try {
            Constructor<T> constr = clazz.getConstructor(InputStream.class);
            res  = constr.newInstance(out);
        } catch (InstantiationException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalArgumentException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InvocationTargetException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NoSuchMethodException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        } catch (SecurityException ex) {
            Logger.getLogger(NullStream.class.getName()).log(Level.SEVERE, null, ex);
        }
        return res;
    }    
}
