package view;

import core.LufBoard;
import interfaces.Tile;
import java.awt.Graphics2D;

/**

 @author reidl
 */
public class BoardPainter {

    private LufBoard board;
    private Tileset tileset;

    public BoardPainter(LufBoard board, Tileset tileset) {
        this.board = board;
        this.tileset = tileset;
    }

    public int getWidth() {
        return board.getWidth() * tileset.getWidth();
    }

    public int getHeight() {
        return board.getHeight() * tileset.getHeight();
    }

    public void paint(Graphics2D g) {
        int boardWidth = board.getWidth();
        int boardHeight = board.getHeight();

        for (int bx = 0; bx < boardWidth; bx++) {
            for (int by = 0; by < boardHeight; by++) {
                Tile tile = board.getTile(bx, by);
                tileset.paint(g, tile.getType(), bx, by);
            }
        }
    }
}
