package view;

import core.TileType;
import core.TileType;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import static core.TileType.*;

/**

 @author reidl
 */
public class Tileset {

    private final int tileWidth, tileHeight;
    private final BufferedImage bitmap;

    public Tileset(int width, int height, BufferedImage bitmap) {
        this.tileWidth = width;
        this.tileHeight = height;
        this.bitmap = bitmap;
    }

    public int getHeight() {
        return tileHeight;
    }

    public int getWidth() {
        return tileWidth;
    }

    public void paint(Graphics2D g, TileType type, int x, int y) {
        System.out.println("Painting " + x + ", " + y);

        int[] tc = tileToCoord(type);
        
        BufferedImage tileImage = bitmap.getSubimage(tc[0] * tileWidth, tc[1] * tileHeight, tileWidth, tileHeight);

        g.drawImage(tileImage, x * tileWidth, y * tileHeight, tileWidth, tileHeight, null);
    }
    
    private static int[] tileToCoord(TileType type) {
        int mask = type.toByte();
        int[] res = new int[2];
        
        // TODO: check.
        res[0] = (mask & 1) | ((mask & 4) >> 1);        
        res[1] = ((mask & 2) >> 1) | ((mask & 8) >> 2);        
                
        return res;
    }
    
    public static void main(String[] args){ 
        TileType[] tiles = TileType.values();
        for (int i = 0; i < tiles.length; i++) {
            TileType type = tiles[i];
            System.out.println(type + ": " + Integer.toBinaryString(type.toByte()) + "\t\t" + tileToCoord(type)[0] + ", " + tileToCoord(type)[1]);
            
        }
    }
}
